#include <iostream>
#include <cmath>
using namespace std;

//Funktion: Taylorreihe
//Inputparameter: x,n
//Outputparameter: y = t(x,n)

double taylor( const double x, int n)
{
double y;
double sum = 0;
for (int i = 1; i<= n;++i)
{
y=pow((x-1),i)/(i*pow(x,i));
sum+=y;
}
return sum;
}

//Hauptprogramm

int main (int argc, char *argv[])
{
double x, y;   //Eingabewert, Rckgabewert
int n;    //Abbbruchindex
cout<<"Geben Sie eine Zahl x > 1/2 ein: "<<endl;
cin>>x; 
 

if (x>0.5)
{
  int n, j=0;
  double diff=6;
    
         while (diff >=(1e-5))
          {
           j=j+1;
           y = taylor(x,j);
           n=j;
           diff = abs(log(x)-y);  
          }
     
     cout<<"Abbruchindex: "<<n<<endl;
     
     cout<<"Die Taylorreihe liefert fuer Ihren Wert "<<x<<" ab dem "<<n<<"-ten Glied eine Genauigkeit von 10^-5 vergl. mit ln("<<x<<")."<<endl;
}
else 
cout<<"Knnen Sie nicht lesen? x muss groesser als 1/2 sein!"<<endl;


system ("pause");
return 0;
}



      
