#include <cstdlib>
#include <iostream>
#include <cmath>
using namespace std;

double t( const double x, int n)
{
       double ln;
       for (int i =1; i<n; ++i)
       {
           ln += pow(-1.0,(i+1))
           * (pow((x-1.0),i+0.0) /i);
       }
       return ln; 
}
       
int main(int argc, char *argv[])
{
    double x;
    int N;
    const double eps = 1e-5;
    
    
    cout << "x = " ;
    cin >> x;
    cout << "n = ";
    cin >> N;
    cout << endl;
    
    cout << log(x);
    cout << endl;
    
    while( abs(log(x)-t(x,N)) <  eps)
    {
    cout << "Taylorreihe: " << t(x,N);
    cout<< endl;
    }
    cout << "n=" << N;
    cout<< endl;
    cout << "Differenz zum exaktem Wert : " << abs(log(x)-t(x,N)) ;
    cout << endl;
    
    
    
  
   
   
    
    
    
    

    system("PAUSE");
    return EXIT_SUCCESS;
}
