//      SS07, Aufg. 16: groesster gemeinsamer Teiler

//	g++ -Wall -pedantic -o bsp_16.exe bsp_16.cpp
#include <iostream>
using namespace std;

//    ggT
int ggT( const int &a, const int &b )
{
  int erg;
  
  if ( a < b )
  {
    erg = ggT(b,a);
  }
  else 
  {
    int rest = a % b;
    if ( rest==0 )
       erg = b;
    else
       erg = ggT( b, rest );
  }  
 
  return erg;
}

//    Hauptprogramm: 
int main(const int argc, const char* argv[])
{
 int c,d;
 
 if (argc > 2)				// at least one argument
  {
   c = atoi(argv[1]);			// atoi : ACSII to Integer
   d = atoi(argv[2]);			// atoi : ACSII to Integer
  }
 else					// standard input
  {
   cout << " Eingabe c : "; cin  >> c;
   cout << " Eingabe d : "; cin  >> d;
   cout << endl;
  }  
  
 int teiler = ggT(c,d);
 
 cout << "\nggT(" << c << "," << d << ") = " << teiler << endl << endl;

 return 0;
}


//           ./bsp_16.exe 5236 5005
//           ggT(7*11*17*4, 7*11*13*5)

