//      SS07, Aufg. 19: Differenzieren

//	g++ -Wall -pedantic bsp_19.cpp
#include <iostream>
#include <cmath>
using namespace std;

//    Differenzieren
double derivative( double (* const func)(double), const double &x, const double &h)
{
  return ( func(x+h) - func(x-h) )/2/h;
}

//    Hauptprogramm: 
int main(const int argc, const char* argv[])
{
 const double h = 0.1;
       double r1,r2,r3;
 
 r1 = derivative(sqrt, 4, h);          //    0.25  : 1/2/sqrt(x)
 
 r2 = derivative(cos, M_PI/6, h);      //   -0.5   :  -sin(x)
 
 r3 = derivative(log, 1, h);           //    1     :  x*ln(x)-x
 
 cout << endl;
 cout << "diff sqrt in x = 4    :  " << r1 << endl;
 cout << "diff cos  in x = pi/6 :  " << r2 << endl;
 cout << "diff log  in x = 1    :  " << r3 << endl;
 

 return 0;
}
