//	SS07, 5. Uebung, Aufgabe24   (Horner)
//	g++ -O3 -Wall -pedantic bsp_24.cpp bsp_24_fkt.cpp

#include <iostream>
#include <cmath>
#include <ctime>
#include <fstream>
using namespace std;
#include "bsp_24_fkt.hpp"

//--------------------------

void test_suite(const string& file, const double x)
{
 double mx,px,hx;
 polynom pp;
 read_koeff(file, pp);

 mx = polynom_mult(x, pp);
 px = polynom_pow (x, pp);
 hx = horner      (x, pp);
 cout << " mx = " << mx << "   px = " << px << "   hx = " << hx <<  endl;

 delete [] pp.a;
}

//--------------------------

int main()
{
 test_suite("data_24_a.txt", 3.78);
 test_suite("data_24_b.txt", -1.0087);
 test_suite("data_24_c.txt", -0.945);

//  system("pause");
 return 0;
}

//       ohne Optimierung (Datensatz c  in bsp_24_clock.cpp)
//   Mult           Power            Horner
// mx = 2.12677   px = 2.12677   hx = 2.12677         // Erg
// t1 = 84.22     t2 = 14.29     t3 = 1.18            // Sec

//       mit Optimierung -O3  (Datensatz c  in bsp_24_clock.cpp)
// mx = 2.12677   px = 2.12677   hx = 2.12677         // Erg
// t1 = 0.38      t2 = 11.82     t3 = 0.53            // Sec



