//	SS07, 2. Uebung, Aufgabe 3   (befreundete Zahlen)
//	g++ bsp_3.cpp

#include <iostream>
#include <cmath>
using namespace std;

int main()
{
 int a,b;		//	zwei ganze Zahlen
//--------------------------------------------------------------------
 //			Dateneingabe
 cout << endl;
 cout << "  Eingabe der positiven ganzen Zahlen  a  und  b " << endl;
 //			Abgesicherte Eingabe fuer a und b
 do 
  {
    cout << "   a = "; cin >> a;
    cout << "   b = "; cin >> b;
    cout << endl;
  }
 while ( a<=0 || b<=0 );

//--------------------------------------------------------------------
//	Test auf befreundete Zahlen
//		Summe der Teiler (mit 1, aber ohne a bzw. b)

//      Summe der Teiler von "a" -- primitive Version
 int sum_a = 0;
 for (int i = 1; i < a; ++i)
 {
   if ( a % i == 0 ) 	// Ist  i  ein Teiler??
   {
     sum_a += i;         
//      cout << "Teiler von a:  " << i << endl;
   }
 }

//      Summe der Teiler von "b" -- bessere Version
       int sum_b = 1;                   // "1" ist stets Teiler
//  const int b_end = floor(sqrt(b+0.0));  // groesster potentieller Teiler
                                           // ganz exakt:
 const int b_end = static_cast<int>(floor(sqrt(b+0.0)));  // groesster potentieller Teiler
 for (int i = 2; i < b_end; ++i)
 {
   if ( b % i == 0 ) 	// Ist  "i"  ein Teiler??
   {
     sum_b += i;         // Wenn "i" Teiler von "a" ist, 
     sum_b += b/i;       // dann auch "b/i" 
//      cout << "Teiler von b:  " << i << "  " << b/i << endl;  
   }
 }
 if ( b_end*b_end == b)  // Achtung bei Quadratzahl "b"
 {
     sum_b += b_end;
 }

//		Ergebnisausgabe  befreundete Zahlen
		
 cout << endl << "Die Zahlen " << a << " und " << b << " sind ";
 if ( sum_a != b || sum_b != a)		// keine befreundeten Zahlen?
  {
    cout << "keine ";
  }
 cout << "befreundete(n) Zahlen" << endl << endl;

//  cout << sum_a << "   " << sum_b << endl;
//  cout << ssqrt(a+0.0) << "   " << sqrt(b+0.0) << endl;

 system("pause");
 return 0;
}
