//     K5 -- Mathe
//  g++ -Wall -W -Wfloat-equal -Wshadow -Wredundant-decls  -pedantic k5_math.cpp
#include <iostream>
#include <cmath>
using namespace std;
// -- geg. Klasse  Point
class Point
{
  public:
    double x,y,z;
};

// -------------- nur die notw. Methoden angeben ---------------
class Polygon
{
 public:
  Polygon(const string& ff) {cout << ff << endl;}  // Dummy zum Compilieren
  ~Polygon()
         { delete [] pp; };

  const Point& operator[](const int& k) const
         { return pp[k]; };

  int size() const
         { return n;};

  private:
    int   n;
    Point *pp;
};
//
class Ebene
{
  public:
   Ebene(const double& a, const double& b, const double& c, const double& d)
         : _a(a), _b(b), _c(c), _d(d)
   {}

   double dist(const Point& p) const
      { return fabs(_a*p.x+_b*p.y+_c*p.z+_d)/sqrt(_a*_a+_b*_b+_c*_c); };

   double minDist(const Polygon& bb, int& k) const;

  private:
    double _a,_b,_c,_d;

};

double Ebene::minDist(const Polygon& bb, int& k) const
{
  double md = -1.0;
  k = -1;
  for (int i=0; i<bb.size(); ++i)
  {
    const double di = dist(bb[i]);
    if ( md < di )
    {
       md = di;
       k  = i;
    }
  }
  return md;
}



//----------    Hauptprogramm    ----------------------
int main()
{
 Ebene   plain(3.2, 4.1, -0.2, 1.9);
 Polygon pp("datafile.txt");    // dieser Konstruktor wird als
                                //          gegeben angenommen!!

//  double d0 =  plain.dist(pp[0]);// Abstand zum Anfang des Polynoms

 int    k_min;                  // Index des Polynompunktes mit
                                //               minimalem Abstand
 double d_min;                  // min.Abstand Polynom--Ebene

                                // Berechne diesen min. Abstand und
 d_min = plain.minDist(pp,k_min);    //        den Index des Punktes

 return 0;
}
