#ifndef BSP_20_FKT
#define BSP_20_FKT

//                       Funktionen aus Aufgabe 20
//    Riemann-Integration
double riemann( double (* const func)(double), const double &a, const double &b, 
		const int n);

//    Differenzieren
double derivative( double (* const func)(double), const double &x, const double &h);

//                       Funktionen aus Aufgabe 21

//    Riemann-Integration (hier klappt Overloading da 4. Parameter anders)
double riemann( double (* const func)(double), const double &a, const double &b, 
		const double eps=1e-4);

//    Differenzieren (andere Funktionsname, da alle Parameter gleich sind 
//                    und die Parameterliste nicht umgestellt wurde)
double derivative2( double (* const func)(double), const double &x, const double eps=1e-4);

#endif
