#ifndef BSP_24_FKT
#define BSP_24_FKT

struct polynom
{
  int n;            // Polynomgrad
  double *a;        // dynam. Array der Koeffizienten
};


void read_koeff(const string& name, polynom& kk);

double polynom_pow(const double x, const polynom& kk);

double polynom_mult(const double x, const polynom& kk);

double horner(const double x, const polynom& kk);

#endif
