#ifndef BSP_27_FKT
#define BSP_27_FKT

#include <iostream>
#include <string>
using namespace std;

class polynom
{
//        Methods
 public:
//
   polynom();
//
   polynom(const polynom& rhs);
//
   polynom(const string& file_name);
//
   ~polynom();
//
   polynom& operator=(const polynom& rhs);
//
   friend ostream & operator<<(ostream  & s, const polynom & orig);
//
   double horner(const double x);
//
   double polynom_mult(const double x);
//
   double polynom_pow(const double x);
//  #########  Playing around with loop unrolling pays off for horner2 and polynom_mult2  #####
   double horner2(const double x);
//
   double horner4(const double x);
//
   double polynom_mult2(const double x);
//  ######### end of playing  ############
//        Members
 private:
   int     ngrad;        // Degree of the polynom
   double *coeff;        // dynam. array of polynomial coefficients for ascending degree,
                         // i.e.  coeff[k] * x^ks
};

#endif
