//	SS07, 4. Uebung, Aufgabe 10 (Pointer)
//            orig.:  3. Uebung, Aufgabe 6   (Vektoren)
//	g++ -Wall -Weffc++ -Woverloaded-virtual -W -Wfloat-equal -Wshadow -Wredundant-decls -Wunreachable-code -Winline -pedantic bsp_10.cpp 
//      valgrind -v --leak-check=yes --tool=memcheck  --log-file=bsp_10 --show-reachable=yes ./a.out



#include <iostream>
#include <cmath>
using namespace std;

int main()
{
 const int N=11;     // Vektorlaenge 
 
 double x[N], u[N];
 
 // Belege x
 const double h=2.0/(N-1);

 for ( int i=0; i<N; ++i)
 {
   *(x+i) = i*h;              // x[i]
//    cout << " " << x[i];
 }
//  cout << endl;
 
 // Belege u
 for (int i=0; i<N; ++i)
 {
   *(u+i) = cos(M_PI* *(x+i) ) * exp(- *(x+i));
 }
 
 // Berechne Skalarprodukt (x,u)
 double sum=0.0;
 double *px=x;          // Pointer-Laufvariable
 for (int i=0; i<N; ++i, ++px)
 {
   sum += *(u+i) * *px;
 }
 
 cout << endl << "Skalarprodukt: " << sum << endl;
 
 
//  system("pause");
 return 0;
}
