//      SS07, Aufg.15, rekursive Funktion, Fibonacci

//	g++ -O3 -Wall bsp_15.cpp
#include <iostream>
using namespace std;

//        Fibonacci-Funktion
long long int fibo(const int n)
{
  long long int ff;

  if ( n > 1 )
  {
     ff = fibo(n-1) + fibo(n-2);
  }
  else if ( n == 1 )
  {
     ff = 1;
  }
  else        //  Fall  n <= 0
  {
     ff = 0;
  }

  return ff;
}

//           Hauptprogramm
int main()
{
 int k;
 cout << " k = "; cin >> k;
 cout << "\n\n Fibonacci fuer " << k << " :  " << fibo(k) << endl << endl;

 return 0;
}

//  Ergebnisse
//    5                 5
//   30           832.040
//   50    12.586.269.025          ( 3 min auf 2.8GHz Pentium4;
//                                  14 min auf 1Ghz/600MHz Laptop )
//   Zeit steigt mit O(1.6^n)
