//      SS07, Aufg. 21: Headerfiles, verbessertes Differenzieren und Integrieren

//	g++ -Wall -pedantic bsp_21.cpp bsp_20_fkt.cpp
#include <iostream>
#include <cmath>
using namespace std;

#include "bsp_20_fkt.hpp"


//    Hauptprogramm: 
int main(const int argc, const char* argv[])
{
 const double EPS = 1e-4;
       double r1,r2,r3;
 
 r1 = riemann(sqrt, 1, 4, EPS);            //    14/3 : 2/3*sqrt(x^3)
 
 r2 = riemann(cos, 0, M_PI/2, EPS);        //    1    :  sin(x)
 
 r3 = riemann(log, 1, M_E, EPS);           //    1    :  x*ln(x)-x
 
 cout << endl;
 cout << "integral sqrt in [1,4]    :  " << r1 << endl;
 cout << "integral cos  in [0,pi/2] :  " << r2 << endl;
 cout << "integral log  in [0,e]    :  " << r3 << endl;
 
 
 cout << endl << endl;
 r1 = derivative2(sqrt, 4, EPS);          //    0.25  : 1/2/sqrt(x)
 
 r2 = derivative2(cos, M_PI/6, EPS);      //   -0.5   :  -sin(x)
 
 r3 = derivative2(log, 1, EPS);           //    1     :  x*ln(x)-x
 
 cout << endl;
 cout << "diff sqrt in x = 4    :  " << r1 << endl;
 cout << "diff cos  in x = pi/6 :  " << r2 << endl;
 cout << "diff log  in x = 1    :  " << r3 << endl;
 

 return 0;
}
