//      SS07, Aufg. 22: Headerfiles, Newton-Iteration

//	g++ -Wall -pedantic bsp_22.cpp bsp_20_fkt.cpp
#include <iostream>
#include <cmath>
using namespace std;

#include "bsp_20_fkt.hpp"

double f(const double x)            // declaration and
  { return sin(x) - 0.5*x ; }       //   definition of function f(x)

double g(const double x)            // declaration and
  { return -(x-1.234567)*(x+0.987654) ; }//   definition of function g(x)

double h(const double x)            // declaration and
  { return 3.0 - exp(x) ; }         //   definition of function h(x)
//  x = 1.09861228866811

double t(const double x)            // declaration and
  { return 1-x*x ; }                //   definition of function t(x)

double z(const double x)            // declaration and
  { return cos(x)-exp(x*log(fabs(x))) ; }                //   definition of function t(x)

//  x = 0.6874391362756255
//  x = -17.27875959474386



//    Hauptprogramm:
int main(const int argc, const char* argv[])
{
//  double x = newton_diff_approx(f, 0.5, 2.0, 1e-12);
//  double x = newton_diff_approx(h, 5, 100, 1e-6);
 double x = newton_diff_approx(z, 0.5, 4, 1e-6);

 cout << endl;
 cout.precision(16);
 cout << "Nullstelle in  x = " << x << endl << endl;
 cout << "Funktionswert " << z(x) << endl;


 return 0;
}
